Loading...
Searching...
No Matches
robottestingframework::ConsoleListener Class Reference

class ConsoleListener listens to any messages reported by the tests during the test run, formates them and print them to the standard output. More...

`#include <robottestingframework/ConsoleListener.h>`

Inheritance diagram for robottestingframework::ConsoleListener:
[legend]

## Public Member Functions

| ConsoleListener (bool verbose=false)
| ConsoleListener constructor.
void | hideUncriticalMessages ()
| hideUncriticalMessages hides the tests report messages and only shows the test assertion failure and error messages.
virtual | ~ConsoleListener ()
| ConsoleListener destructor.
void | addReport (const Test *test, TestMessage msg) override
| This is called to report any arbitrary message from tests.
void | addError (const Test *test, TestMessage msg) override
| This is called when an error occurred during test run.
void | addFailure (const Test *test, TestMessage msg) override
| This is called when a failure occurred during test run.
void | startTest (const Test *test) override
| This is called when a Test is started.
void | endTest (const Test *test) override
| This is called when a Test is finished.
void | startTestSuite (const Test *test) override
| This is called when a TestSuite is started.
void | endTestSuite (const Test *test) override
| This is called when a TestSuite is finished.
void | startTestRunner () override
| This is called when the TestRunner is started.
void | endTestRunner () override
| This is called when the TestRunner is finished.
Public Member Functions inherited from robottestingframework::TestListener
| TestListener ()=default
| TestListener constructor.
virtual | ~TestListener ()=default
| TestListener destructor.

## Private Attributes

bool | verbose
bool | hideUncritical

## Detailed Description

class ConsoleListener listens to any messages reported by the tests during the test run, formates them and print them to the standard output.

Here's an example of using a ConsoleListener:

/*
* Robot Testing Framework
*
* Copyright (C) 2015-2019 Istituto Italiano di Tecnologia (IIT)
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/
#include <robottestingframework/ConsoleListener.h>
#include <robottestingframework/TestAssert.h>
#include <robottestingframework/TestCase.h>
#include <robottestingframework/TestResult.h>
#include <robottestingframework/TestResultCollector.h>
#include <cstdio>
#include <iostream>
using namespace robottestingframework;
class MyTest : public TestCase
{
public:
MyTest() :
TestCase("MyTest")
{
}
bool setup(int argc, char** argv) override
{
ROBOTTESTINGFRAMEWORK_TEST_REPORT("running MyTest::setup...");
return true;
}
void tearDown() override
{
ROBOTTESTINGFRAMEWORK_TEST_REPORT("running MyTest::teardown...");
ROBOTTESTINGFRAMEWORK_ASSERT_ERROR("this is just for example!");
}
void run() override
{
ROBOTTESTINGFRAMEWORK_TEST_CHECK(2 < 3, "two is less than three");
ROBOTTESTINGFRAMEWORK_TEST_CHECK(2 == 3, "two is equal to three");
int a = 5;
int b = 3;
ROBOTTESTINGFRAMEWORK_TEST_FAIL_IF_FALSE(a < b, Asserter::format("%d is not smaller than %d.", a, b));
}
};
int main(int argc, char** argv)
{
// create a test listener to collect the result
// and enable the verbose mode
ConsoleListener listener(true);
// create a collector to get computer readable
// test results
TestResultCollector collector;
// create a test result and add the listeners
TestResult result;
result.addListener(&listener);
result.addListener(&collector);
// calling a test case
MyTest atest;
atest.TestCase::run(result);
// return 0 if the test passed
// otherwise the number of failed test
return collector.failedCount();
}
ConsoleListener.h
TestAssert.h
ROBOTTESTINGFRAMEWORK_ASSERT_ERROR
#define ROBOTTESTINGFRAMEWORK_ASSERT_ERROR(message)
Assertion with throwing error exception.
Definition TestAssert.h:90
ROBOTTESTINGFRAMEWORK_TEST_CHECK
#define ROBOTTESTINGFRAMEWORK_TEST_CHECK(condition, message)
ROBOTTESTINGFRAMEWORK_TEST_CHECK combines ROBOTTESTINGFRAMEWORK_TEST_REPORT and ROBOTTESTINGFRAMEWORK...
Definition TestAssert.h:188
ROBOTTESTINGFRAMEWORK_TEST_FAIL_IF_FALSE
#define ROBOTTESTINGFRAMEWORK_TEST_FAIL_IF_FALSE(condition, message)
Conditional failure report.
Definition TestAssert.h:149
ROBOTTESTINGFRAMEWORK_TEST_REPORT
#define ROBOTTESTINGFRAMEWORK_TEST_REPORT(message)
Reporting a message to the TestResult.
Definition TestAssert.h:131
TestCase.h
TestResultCollector.h
TestResult.h
robottestingframework::ConsoleListener
class ConsoleListener listens to any messages reported by the tests during the test run,...
Definition ConsoleListener.h:39
robottestingframework::TestCase
The base class to implememnt a test case.
Definition TestCase.h:42
robottestingframework::TestResultCollector
The TestResultCollector class can be used to store all the events issued by the test cases,...
Definition TestResultCollector.h:44
robottestingframework::TestResultCollector::failedCount
unsigned int failedCount()
failedCount gets the number of failed test cases.
robottestingframework::TestResult
The TestResult class is used to deliver the test results including any error and failures produced by...
Definition TestResult.h:44
robottestingframework::TestResult::addListener
void addListener(TestListener *listener)
Adding a new listener.
robottestingframework
Definition Arguments.h:25

Examples
  simple.cpp, simple_collector.cpp, simple_fixture.cpp, simple_runner.cpp, and simple_suite.cpp.

Definition at line 38 of file ConsoleListener.h.

## Constructor & Destructor Documentation

## ConsoleListener()

robottestingframework::ConsoleListener::ConsoleListener | ( | bool | verbose = `false` | ) |

ConsoleListener constructor.

Parameters

  verbose | enables the verbose mode. If `true`, the source file and the line number where the messages are issued by the tests will be written to the standard output. The verbose mode is disabled by default.

## ~ConsoleListener()

virtual robottestingframework::ConsoleListener::~ConsoleListener | ( |  | ) |

virtual

ConsoleListener destructor.

## Member Function Documentation

## addError()

void robottestingframework::ConsoleListener::addError | ( | const Test * | test,
|  | TestMessage | msg
| ) |  |

override virtual

This is called when an error occurred during test run.

Parameters

  test | pointer to the corresponding test
  msg | correspoinding error message

Reimplemented from robottestingframework::TestListener.

## addFailure()

void robottestingframework::ConsoleListener::addFailure | ( | const Test * | test,
|  | TestMessage | msg
| ) |  |

override virtual

This is called when a failure occurred during test run.

Parameters

  test | pointer to the corresponding test
  msg | correspoinding failure message

Reimplemented from robottestingframework::TestListener.

## addReport()

void robottestingframework::ConsoleListener::addReport | ( | const Test * | test,
|  | TestMessage | msg
| ) |  |

override virtual

This is called to report any arbitrary message from tests.

Parameters

  test | pointer to the corresponding test
  msg | correspoinding error message

Reimplemented from robottestingframework::TestListener.

## endTest()

void robottestingframework::ConsoleListener::endTest | ( | const Test * | test | ) |

override virtual

This is called when a Test is finished.

Parameters

  test | pointer to the corresponding test

Reimplemented from robottestingframework::TestListener.

## endTestRunner()

void robottestingframework::ConsoleListener::endTestRunner | ( |  | ) |

override virtual

This is called when the TestRunner is finished.

Reimplemented from robottestingframework::TestListener.

## endTestSuite()

void robottestingframework::ConsoleListener::endTestSuite | ( | const Test * | test | ) |

override virtual

This is called when a TestSuite is finished.

Parameters

  test | pointer to the corresponding test

Reimplemented from robottestingframework::TestListener.

## hideUncriticalMessages()

void robottestingframework::ConsoleListener::hideUncriticalMessages | ( |  | ) |

hideUncriticalMessages hides the tests report messages and only shows the test assertion failure and error messages.

## startTest()

void robottestingframework::ConsoleListener::startTest | ( | const Test * | test | ) |

override virtual

This is called when a Test is started.

Parameters

  test | pointer to the corresponding test

Reimplemented from robottestingframework::TestListener.

## startTestRunner()

void robottestingframework::ConsoleListener::startTestRunner | ( |  | ) |

override virtual

This is called when the TestRunner is started.

Reimplemented from robottestingframework::TestListener.

## startTestSuite()

void robottestingframework::ConsoleListener::startTestSuite | ( | const Test * | test | ) |

override virtual

This is called when a TestSuite is started.

Parameters

  test | pointer to the corresponding test

Reimplemented from robottestingframework::TestListener.

## Member Data Documentation

## hideUncritical

bool robottestingframework::ConsoleListener::hideUncritical

private

Definition at line 119 of file ConsoleListener.h.

## verbose

bool robottestingframework::ConsoleListener::verbose

private

Definition at line 118 of file ConsoleListener.h.

The documentation for this class was generated from the following file:

- src/robottestingframework/include/robottestingframework/ConsoleListener.h